NPMIP_a_Parameters = [
	["MenuWidth",          150,		"number"],
	["FontFamily",         null],
	["FontSize",           10,		"number"],
	["FontBold",           false,	"boolean"],
	["FontItalic",         false,	"boolean"],
	["FontColor",          "black"],
	["FontColorOver",      "white"],
	["BGColor",            "white"],
	["BGColorOver",        "black"],
	["ItemPadding",        3,		"number"],
	["BorderWidth",        2,		"number"],
	["BorderColor",        "red"],
	["SeparatorSize",      1,		"number"],
	["ImageSrc",           null],
	["ImageSrcOver",       null],
	["ImageSrcLeft",       null],
	["ImageSrcLeftOver",   null],
	["ImageSize",          5,		"number"],
	["ImageHorizSpace",    0,		"number"],
	["ImageVertSpace",     0,		"number"],
	["KeepHilite",         false,	"boolean"],
	["ClickStart",         false,	"boolean"],
	["ClickKill",          true,	"boolean"],
	["ChildOverlap",       20,		"number"],
	["ChildOffset",        10,		"number"],
	["ChildPerCentOver",   null,	"number"],
	["TopSecondsVisible",  .5,		"number"],
	["ChildSecondsVisible",.3,		"number"],
	["StatusDisplayBuild", 1,		"boolean"],
	["StatusDisplayLink",  1,		"boolean"],
	["UponDisplay",        null,	"delayed"],
	["UponHide",           null,	"delayed"],
	["RightToLeft",        false,	"boolean"],
	["CreateTopOnly",      0,		"boolean"],
	["ShowLinkCursor",     false,	"boolean"],
	["NSFontOver",		   true,	"boolean"]
]

NPMIP_MenuIDPrefix = "NPMIP_Menu";
NPMIP_ItemIDPrefix = "NPMIP_Item";
NPMIP_ArrayIDPrefix = "NPMIP_Array";
NPMIP_Link = null;

Function.prototype.isFunction = true;
Function.prototype.isString = false;
String.prototype.isFunction = false;
String.prototype.isString = true;
String.prototype.isBoolean = false;
String.prototype.isNumber = false;
Number.prototype.isString = false;
Number.prototype.isFunction = false;
Number.prototype.isBoolean = false;
Number.prototype.isNumber = true;
Boolean.prototype.isString = false;
Boolean.prototype.isFunction = false;
Boolean.prototype.isBoolean = true;
Boolean.prototype.isNumber = false;
Array.prototype.itemValidation = false;
Array.prototype.isArray = true;


function NPMIP_f_AssignParameters(paramarray){
	var ParamName = paramarray[0];
	var DefaultValue = paramarray[1];
	var FullParamName = "NPMIP_" + ParamName;

	if (typeof eval("window.NPMIP_PG_" + ParamName) == "undefined") {
		if (typeof eval("window.NPMIP_GL_" + ParamName) == "undefined") {
			eval(FullParamName + "= DefaultValue");
		}
		else {
			eval(FullParamName + "= NPMIP_GL_" + ParamName);
		}
	}
	else {
		eval(FullParamName + "= NPMIP_PG_" + ParamName);
	}

	paramarray[0] = FullParamName;
	paramarray[1] = eval(FullParamName);
}

function NPMIP_f_EvalParameters(valuenew,valueold,valuetype){
	var TestString, ParPosition;

	if(typeof valuenew == "undefined" || valuenew == null || (valuenew.isString && valuenew.length == 0)){
		return valueold;
	}

	if(valuetype != "delayed"){
		while(valuenew.isString) {
			ParPosition = valuenew.indexOf("(");
			if(ParPosition !=-1) {
				TestString = "window." + valuenew.substr(0,ParPosition);
				if (typeof eval(TestString) != "undefined" && eval(TestString).isFunction) {
					valuenew = eval(valuenew);
				}
			}
			else break
		}
	}

	while(valuenew.isFunction) {valuenew = valuenew()}

	switch(valuetype){	
		case "number":
			while (valuenew.isString) {valuenew = eval(valuenew)}
			break;
		case "boolean":
			while (!valuenew.isBoolean) {
				valuenew = (valuenew.isNumber) ? valuenew ? true : false : eval(valuenew);
			}
			break;
	}

	return valuenew;
}

for (i=0;i<NPMIP_a_Parameters.length;i++) {
	NPMIP_f_AssignParameters(NPMIP_a_Parameters[i]);
	eval(NPMIP_a_Parameters[i][0] + "= NPMIP_f_EvalParameters("+ NPMIP_a_Parameters[i][0] +",null,NPMIP_a_Parameters[i][2])")
}

NPMIP_ChildPerCentOver = (isNaN(parseFloat(NPMIP_ChildPerCentOver))) ? null : parseFloat(NPMIP_ChildPerCentOver)/100;

NPMIP_ChildMilliSecondsVisible = NPMIP_ChildSecondsVisible * 1000;

function NPMIP_f_ValidateArray(arrayname){
	var MenuArrayIsValid = false;
	var MenuArrayIsObject = (typeof eval("window." + arrayname) == "object");
	if(MenuArrayIsObject) { 
		var TheMenuArray = eval(arrayname);
		if(TheMenuArray.isArray && TheMenuArray.length > 1) {
			MenuArrayIsValid = true;
			if(!TheMenuArray.itemValidation) {
				while((typeof TheMenuArray[TheMenuArray.length-1] != "object") || (!TheMenuArray[TheMenuArray.length-1].isArray)) {
					TheMenuArray.length--;
				}
				TheMenuArray.itemValidation = true;
			}
		}
	}
	return MenuArrayIsValid;
}

if(!window.NPMIP_a_TreesToBuild) {
	NPMIP_a_TreesToBuild = [];
	for(i=1; i<100; i++){
		if(NPMIP_f_ValidateArray(NPMIP_ArrayIDPrefix + i)) NPMIP_a_TreesToBuild[NPMIP_a_TreesToBuild.length] = i;
	}
}

NPMIP_CurrentArray = null;
NPMIP_CurrentTree  = null;
NPMIP_CurrentMenu  = null;
NPMIP_CurrentItem  = null;
NPMIP_a_TopMenus = [];
NPMIP_AreLoaded = false;
NPMIP_AreCreated = false;
NPMIP_BeingCreated = false;
NPMIP_UserOverMenu = false;
NPMIP_HideAllTimer = null;
NPMIP_TotalTrees = 0;
NPMIP_ZIndex = 5000;

function NPMIP_f_Initialize() {
    if(NPMIP_AreCreated) {
		for(var i=0; i<NPMIP_TotalTrees; i++) {
			var TopMenu = NPMIP_a_TopMenus[i];
			clearTimeout(TopMenu.hideTimer);
			TopMenu.hideTimer = null;
        }
        clearTimeout(NPMIP_HideAllTimer);
    }
	NPMIP_AreCreated = false;
	NPMIP_BeingCreated = false;
	NPMIP_UserOverMenu = false;
	NPMIP_CurrentMenu = null;
	NPMIP_HideAllTimer = null;
	NPMIP_TotalTrees = 0;
	NPMIP_a_TopMenus = [];
}

Layer.prototype.showIt = NPMIP_f_ShowIt;
Layer.prototype.keepInWindow = NPMIP_f_KeepInWindow;
Layer.prototype.hideTree = NPMIP_f_HideTree
Layer.prototype.hideParents = NPMIP_f_HideParents;
Layer.prototype.hideChildren = NPMIP_f_HideChildren;
Layer.prototype.hideTop = NPMIP_f_HideTop;
Layer.prototype.hideSelf = NPMIP_f_HideSelf;
Layer.prototype.hasChildVisible = false;
Layer.prototype.isOn = false;
Layer.prototype.hideTimer = null;
Layer.prototype.currentItem = null;
Layer.prototype.itemSetup = NPMIP_f_ItemSetup;
Layer.prototype.itemCount = 0;
Layer.prototype.child = null;
Layer.prototype.isWritten = false;

NPMIP_NS_OrigWidth  = window.innerWidth;
NPMIP_NS_OrigHeight = window.innerHeight;

window.onresize = function (){
    if (window.innerWidth == NPMIP_NS_OrigWidth && window.innerHeight == NPMIP_NS_OrigHeight) return;
    NPMIP_f_Initialize();
	window.history.go(0);
}

function NPMIP_f_StartIt() {
	if(NPMIP_AreCreated) return;
	NPMIP_AreLoaded = true;
	if (NPMIP_ClickKill) {
		NPMIP_f_OtherMouseDown = (document.onmousedown) ? document.onmousedown :  new Function;
		document.captureEvents(Event.MOUSEDOWN);
    	document.onmousedown = function(){NPMIP_f_PageClick();NPMIP_f_OtherMouseDown()}
    }
	else {
		NPMIP_TopMilliSecondsVisible = NPMIP_TopSecondsVisible * 1000;
	}
    NPMIP_f_MakeTrees();
	NPMIP_f_OtherOnLoad();
}

function NPMIP_f_MakeTrees(){
    NPMIP_BeingCreated = true;
	var TreeParams = null;
	var TreeHasChildren = false;
	var ItemArray = null;

	for(var t=0; t<NPMIP_a_TreesToBuild.length; t++) {
		if(!NPMIP_f_ValidateArray(NPMIP_ArrayIDPrefix + NPMIP_a_TreesToBuild[t])) continue;
		NPMIP_CurrentArray = eval(NPMIP_ArrayIDPrefix + NPMIP_a_TreesToBuild[t]);

		TreeParams = NPMIP_CurrentArray[0];
		TreeHasChildren = false;

		for(var i=1; i<NPMIP_CurrentArray.length; i++) {
			ItemArray = NPMIP_CurrentArray[i];
			if(ItemArray[ItemArray.length-1]) {TreeHasChildren = true; break}
		}

		NPMIP_CurrentTree = {
			MenuWidth        : MenuWidth = NPMIP_f_EvalParameters(TreeParams[0],NPMIP_MenuWidth,"number"),
			MenuLeft         : MenuLeft = NPMIP_f_EvalParameters(TreeParams[1],null,"delayed"),
			MenuTop          : MenuTop = NPMIP_f_EvalParameters(TreeParams[2],null,"delayed"),
			ItemWidth        : ItemWidth = MenuWidth - (NPMIP_BorderWidth*2),
			ItemTextWidth    : TreeHasChildren ? (ItemWidth - (NPMIP_ImageSize + NPMIP_ImageHorizSpace + NPMIP_ItemPadding)) : ItemWidth,
			FontColor        : FontColor = NPMIP_f_EvalParameters(TreeParams[3],NPMIP_FontColor),
			FontColorOver    : FontColorOver = NPMIP_f_EvalParameters(TreeParams[4],NPMIP_FontColorOver),
			BGColor          : NPMIP_f_EvalParameters(TreeParams[5],NPMIP_BGColor),
			BGColorOver      : NPMIP_f_EvalParameters(TreeParams[6],NPMIP_BGColorOver),
			BorderColor      : NPMIP_f_EvalParameters(TreeParams[7],NPMIP_BorderColor),
			TopIsPermanent   : ((MenuLeft == null) || (MenuTop == null)) ? false : NPMIP_f_EvalParameters(TreeParams[9],false,"boolean"),
			TopIsHorizontal  : TopIsHorizontal = NPMIP_f_EvalParameters(TreeParams[10],false,"boolean"),
			TreeIsHorizontal : TreeHasChildren ? NPMIP_f_EvalParameters(TreeParams[11],false,"boolean") : false,
			PositionUnder    : (!TopIsHorizontal || !TreeHasChildren) ? false : NPMIP_f_EvalParameters(TreeParams[12],false,"boolean"),
			TopImageShow     : TreeHasChildren ? NPMIP_f_EvalParameters(TreeParams[13],true,"boolean")  : false,
			TreeImageShow    : TreeHasChildren ? NPMIP_f_EvalParameters(TreeParams[14],true,"boolean")  : false,
			UponDisplay      : NPMIP_f_EvalParameters(TreeParams[15],NPMIP_UponDisplay,"delayed"),
			UponHide         : NPMIP_f_EvalParameters(TreeParams[16],NPMIP_UponHide,"delayed"),
			RightToLeft      : NPMIP_f_EvalParameters(TreeParams[17],NPMIP_RightToLeft,"boolean"),
			NSFontOver		 : NPMIP_NSFontOver ? (FontColor != FontColorOver) : false,
			ClickStart		 : NPMIP_f_EvalParameters(TreeParams[18],NPMIP_ClickStart,"boolean"),
			TopIsVariableWidth  : NPMIP_f_EvalParameters(TreeParams[19],false,"boolean"),
			TreeIsVariableWidth  : NPMIP_f_EvalParameters(TreeParams[20],false,"boolean")
		}

		NPMIP_CurrentMenu = null;
		NPMIP_f_MakeMenu(NPMIP_a_TreesToBuild[t]);
		NPMIP_a_TopMenus[NPMIP_TotalTrees] = NPMIP_CurrentTree.treeParent;
		NPMIP_TotalTrees++;
		if(NPMIP_CurrentTree.TopIsPermanent){
			with(NPMIP_CurrentTree.treeParent) {
				moveTo(eval(NPMIP_CurrentTree.MenuLeft),eval(NPMIP_CurrentTree.MenuTop));
				zIndex = NPMIP_ZIndex;
				visibility = "show";
			}
		}
    }

	//if(NPMIP_StatusDisplayBuild) status = NPMIP_TotalTrees + " Hierarchical Menu Trees Created";
	if(NPMIP_StatusDisplayBuild) status = "SysPoint";
    NPMIP_AreCreated = true;
    NPMIP_BeingCreated = false;
}

function NPMIP_f_GetItemHtmlStr(arraystring){
	var TempString = arraystring;
	if (NPMIP_FontBold) TempString = TempString.bold();
	if (NPMIP_FontItalic) TempString = TempString.italics();
	TempString = "<FONT FACE='" + NPMIP_FontFamily + "' POINT-SIZE=" + NPMIP_FontSize + ">" + TempString + "</FONT>";
	var TempStringOver = TempString.fontcolor(NPMIP_CurrentTree.FontColorOver);
	TempString = TempString.fontcolor(NPMIP_CurrentTree.FontColor);
	return [TempString,TempStringOver];
}

function NPMIP_f_MakeMenu(menucount) {
	if(!NPMIP_f_ValidateArray(NPMIP_ArrayIDPrefix + menucount)) return false;
	NPMIP_CurrentArray = eval(NPMIP_ArrayIDPrefix + menucount);

	NewMenu = eval("window." + NPMIP_MenuIDPrefix + menucount);
	if(!NewMenu) {
		eval(NPMIP_MenuIDPrefix + menucount + " = new Layer(NPMIP_CurrentTree.MenuWidth,window)");
		NewMenu = eval(NPMIP_MenuIDPrefix + menucount);
	
		if(NPMIP_CurrentMenu) {
			NewMenu.parentMenu = NPMIP_CurrentMenu;
			NewMenu.parentItem = NPMIP_CurrentItem;
			NewMenu.parentItem.child = NewMenu;
			NewMenu.hasParent = true;
			NewMenu.isHorizontal = NPMIP_CurrentTree.TreeIsHorizontal;
			NewMenu.showImage = NPMIP_CurrentTree.TreeImageShow;
		}
		else {
			NewMenu.isHorizontal = NPMIP_CurrentTree.TopIsHorizontal;
			NewMenu.showImage = NPMIP_CurrentTree.TopImageShow;
		}
	
		NPMIP_CurrentMenu = NewMenu;
		NPMIP_CurrentMenu.count = menucount;
		NPMIP_CurrentMenu.tree  = NPMIP_CurrentTree;
		NPMIP_CurrentMenu.array = NPMIP_CurrentArray;
		NPMIP_CurrentMenu.maxItems = NPMIP_CurrentArray.length - 1;
		NPMIP_CurrentMenu.bgColor = NPMIP_CurrentTree.BorderColor;
		NPMIP_CurrentMenu.IsVariableWidth = ((NPMIP_CurrentMenu.hasParent && NPMIP_CurrentTree.TreeIsVariableWidth) || (!NPMIP_CurrentMenu.hasParent && NPMIP_CurrentTree.TopIsVariableWidth));
	    NPMIP_CurrentMenu.onmouseover = NPMIP_f_MenuOver;
	    NPMIP_CurrentMenu.onmouseout = NPMIP_f_MenuOut;
		NPMIP_CurrentMenu.moveTo(0,0);
	}

	if(!NPMIP_CurrentTree.treeParent) NPMIP_CurrentTree.treeParent = NPMIP_CurrentTree.startChild = NPMIP_CurrentMenu;

	while (NPMIP_CurrentMenu.itemCount < NPMIP_CurrentMenu.maxItems) {
		NPMIP_CurrentMenu.itemCount++;
		NPMIP_CurrentItem = eval("window." + NPMIP_ItemIDPrefix + menucount + "_" + NPMIP_CurrentMenu.itemCount);
		if(!NPMIP_CurrentItem) {
			eval(NPMIP_ItemIDPrefix + menucount + "_" + NPMIP_CurrentMenu.itemCount + " = new Layer(NPMIP_CurrentTree.ItemWidth - (NPMIP_ItemPadding*2),NPMIP_CurrentMenu)")
			//if(NPMIP_StatusDisplayBuild) status = "Creating Hierarchical Menus: " + menucount + " / " + NPMIP_CurrentMenu.itemCount;
			NPMIP_CurrentItem = eval(NPMIP_ItemIDPrefix + menucount + "_" + NPMIP_CurrentMenu.itemCount);
			NPMIP_CurrentItem.itemSetup(menucount + "_" + NPMIP_CurrentMenu.itemCount);
		}
		if(NPMIP_CurrentItem.hasMore && (!NPMIP_CreateTopOnly || NPMIP_AreCreated && NPMIP_CreateTopOnly)) {
	       	MenuCreated = NPMIP_f_MakeMenu(menucount + "_" + NPMIP_CurrentMenu.itemCount);
           	if(MenuCreated) {
				NPMIP_CurrentMenu =  NPMIP_CurrentMenu.parentMenu;
				NPMIP_CurrentArray = NPMIP_CurrentMenu.array;
			}
		}
    }
	NPMIP_CurrentMenu.itemCount = 0;
	if (NPMIP_CurrentMenu.isHorizontal) {
	    NPMIP_CurrentMenu.clip.right = NPMIP_CurrentMenu.lastItem.left + NPMIP_CurrentMenu.lastItem.clip.right + NPMIP_BorderWidth;
	}
	else {
	    NPMIP_CurrentMenu.clip.right = NPMIP_CurrentMenu.lastItem.clip.width + (NPMIP_BorderWidth*2);
	}
    NPMIP_CurrentMenu.clip.bottom = NPMIP_CurrentMenu.lastItem.top + NPMIP_CurrentMenu.lastItem.clip.bottom + NPMIP_BorderWidth;
	return NPMIP_CurrentMenu;
}

function NPMIP_f_ItemSetup(itemidsuffix) {
	this.menu = NPMIP_CurrentMenu;	
	this.tree = NPMIP_CurrentTree;
	this.index = NPMIP_CurrentMenu.itemCount - 1;
	this.array = NPMIP_CurrentArray[NPMIP_CurrentMenu.itemCount];
	this.dispText = this.array[0];
	this.linkText = this.array[1];
	this.permHilite  = NPMIP_f_EvalParameters(this.array[3],false,"boolean");
	this.hasRollover = (!this.permHilite && NPMIP_f_EvalParameters(this.array[2],true,"boolean"));
	this.hasMore	 = NPMIP_f_EvalParameters(this.array[4],false,"boolean") && NPMIP_f_ValidateArray(NPMIP_ArrayIDPrefix + itemidsuffix);
	var HtmlStrings = NPMIP_f_GetItemHtmlStr(this.dispText);
	this.htmStr = HtmlStrings[0];
	this.htmStrOver = HtmlStrings[1];
	this.visibility = "inherit";
        this.onmouseover = NPMIP_f_ItemOver;
	this.onmouseout  = NPMIP_f_ItemOut;
	this.menu.lastItem = this;
	this.showChild = NPMIP_f_ShowChild;

	this.ClickStart = this.hasMore && this.tree.ClickStart && (this.tree.TopIsPermanent && (this.tree.treeParent==this.menu));
	if(this.ClickStart) {
		this.captureEvents(Event.MOUSEUP);
		this.onmouseup = this.showChild;
		this.linkText = "";
	}
	else {
	    if (this.linkText) {
			this.captureEvents(Event.MOUSEUP);
			this.onmouseup = NPMIP_f_LinkIt;
	    }
	}

	this.txtLyrOff = new Layer(NPMIP_CurrentTree.ItemTextWidth - (NPMIP_ItemPadding*2),this);
	with(this.txtLyrOff) {
		document.write(this.permHilite ? this.htmStrOver : this.htmStr);
		document.close();
		if (NPMIP_CurrentTree.RightToLeft && this.menu.showImage && (!this.menu.isHorizontal || (this.menu.isHorizontal && (!this.menu.IsVariableWidth || (this.menu.IsVariableWidth && this.hasMore))) )) left = NPMIP_ItemPadding + NPMIP_ImageSize + NPMIP_ImageHorizSpace;
		visibility = "inherit";
	}

	if(this.menu.IsVariableWidth){
		this.ItemTextWidth = this.txtLyrOff.document.width;
		this.ItemWidth = this.ItemTextWidth + (NPMIP_ItemPadding*2);
		if(NPMIP_CurrentMenu.showImage) {
			if(!this.menu.isHorizontal || this.hasMore) {
				this.ItemWidth += (NPMIP_ItemPadding + NPMIP_ImageSize + NPMIP_ImageHorizSpace);
			}
		}
	}
	else {
		this.ItemWidth = this.tree.ItemWidth;
		this.ItemTextWidth = this.tree.ItemTextWidth;
	}
	if (this.menu.isHorizontal) {
    	if (this.index) this.left = this.siblingBelow.left + this.siblingBelow.clip.width + NPMIP_SeparatorSize;
		else this.left = (NPMIP_BorderWidth + NPMIP_ItemPadding);
		this.top = (NPMIP_BorderWidth + NPMIP_ItemPadding);
	}
	else {
		this.left = (NPMIP_BorderWidth + NPMIP_ItemPadding);
	    if (this.index) this.top = this.siblingBelow.top + this.siblingBelow.clip.height + NPMIP_SeparatorSize;
    	else this.top = (NPMIP_BorderWidth + NPMIP_ItemPadding)
	}
    this.clip.top = this.clip.left = -NPMIP_ItemPadding;
    this.clip.right = this.ItemWidth - NPMIP_ItemPadding;
	this.bgColor = this.permHilite ? this.tree.BGColorOver : this.tree.BGColor;

	if(this.tree.NSFontOver) {
		if(!this.permHilite){
			this.txtLyrOn = new Layer(this.ItemTextWidth,this);
			with(this.txtLyrOn) {
				if (NPMIP_CurrentTree.RightToLeft && this.menu.showImage && (!this.menu.isHorizontal || (this.menu.isHorizontal && (!this.menu.IsVariableWidth || (this.menu.IsVariableWidth && this.hasMore))) ))  left = NPMIP_ItemPadding + NPMIP_ImageSize + NPMIP_ImageHorizSpace;
				visibility = "hide";
			}
		}
	}

	this.fullClip = this.txtLyrOff.document.height + (NPMIP_ItemPadding * 2);
	if(this.menu.isHorizontal) {
		if(this.index) {
			var SiblingHeight = this.siblingBelow.clip.height;
			this.fullClip = Math.max(SiblingHeight,this.fullClip);
			if(this.fullClip > SiblingHeight) {
				var SiblingPrevious = this.siblingBelow;
				while(SiblingPrevious != null) {
					SiblingPrevious.clip.height = this.fullClip;
					SiblingPrevious = SiblingPrevious.siblingBelow;
				}
			}
		}
	}
	this.clip.height = this.fullClip;

	if(!this.menu.isHorizontal && this.menu.IsVariableWidth) {
		this.fullWidth = this.clip.width;
		if(this.index) {
			var SiblingWidth = this.siblingBelow.clip.width;
			this.fullWidth = Math.max(SiblingWidth,this.fullWidth);
			SiblingPrevious = this.siblingBelow;
			while(SiblingPrevious != null) {
				SiblingPrevious.clip.width = this.fullWidth;
				SiblingPrevious.dummyLyr.clip.width = this.fullWidth;
				if(SiblingPrevious.hasMore) {
					SiblingPrevious.DistanceToRightEdge = SiblingPrevious.clip.right + SiblingPrevious.WhatsOnRight;
					SiblingPrevious.DistanceToLeftEdge = NPMIP_ItemPadding + SiblingPrevious.WhatsOnLeft;
					SiblingPrevious.CompleteWidth = SiblingPrevious.ItemWidth + SiblingPrevious.WhatsOnLeft + SiblingPrevious.WhatsOnRight;
					SiblingPrevious.ChildOverlap = (parseInt((NPMIP_ChildPerCentOver != null) ? (NPMIP_ChildPerCentOver  * SiblingPrevious.CompleteWidth) : NPMIP_ChildOverlap));
				}
				if(SiblingPrevious.imgLyr && !NPMIP_CurrentTree.RightToLeft) {
					SiblingPrevious.imgLyr.left = this.fullWidth - (NPMIP_ItemPadding * 2) - NPMIP_ImageSize - NPMIP_ImageHorizSpace;
				}
				SiblingPrevious = SiblingPrevious.siblingBelow;
			}
		}
		this.clip.width = this.fullWidth;
	}

	this.dummyLyr = new Layer(100,this);
	with(this.dummyLyr) {
		left = top = -NPMIP_ItemPadding;
		clip.width = this.clip.width;
		clip.height = this.clip.height;
		visibility = "inherit";
	}

	if(this.hasMore && NPMIP_CurrentMenu.showImage) {
		this.imageSrc = this.tree.RightToLeft ? NPMIP_ImageSrcLeft : NPMIP_ImageSrc;
		this.hasImageRollover = ((!this.tree.RightToLeft && NPMIP_ImageSrcOver) || (this.tree.RightToLeft && NPMIP_ImageSrcLeftOver));
		if(this.hasImageRollover) {
			this.imageSrcOver = this.tree.RightToLeft ? NPMIP_ImageSrcLeftOver : NPMIP_ImageSrcOver;
			if(this.permHilite) this.imageSrc = this.imageSrcOver;
		}
		this.imgLyr = new Layer(NPMIP_ImageSize,this);

		with(this.imgLyr) {
			document.write("<IMG SRC='" + this.imageSrc + "' WIDTH=" + NPMIP_ImageSize + " VSPACE=0 HSPACE=0 BORDER=0>");
			document.close();
			moveBelow(this.txtLyrOff);
			left = (NPMIP_CurrentTree.RightToLeft) ? NPMIP_ImageHorizSpace : this.ItemWidth - (NPMIP_ItemPadding * 2) - NPMIP_ImageSize - NPMIP_ImageHorizSpace;
			top = NPMIP_ImageVertSpace;
			visibility = "inherit";
		}
		this.imageElement = this.imgLyr.document.images[0];
	}

	if(this.hasMore) {
		this.WhatsOnRight = (!this.menu.isHorizontal || (this.menu.isHorizontal && this.isLastItem)) ?  NPMIP_BorderWidth : NPMIP_SeparatorSize;
		this.DistanceToRightEdge = this.clip.right + this.WhatsOnRight;
		this.WhatsOnLeft = (!this.menu.isHorizontal || (this.menu.isHorizontal && this.index==0)) ? NPMIP_BorderWidth : NPMIP_SeparatorSize;
		this.DistanceToLeftEdge = NPMIP_ItemPadding + this.WhatsOnLeft;
		this.CompleteWidth = this.ItemWidth + this.WhatsOnLeft + this.WhatsOnRight;
		this.ChildOverlap = (parseInt((NPMIP_ChildPerCentOver != null) ? (NPMIP_ChildPerCentOver  * this.CompleteWidth) : NPMIP_ChildOverlap));
	}
}

function setLinkAndGo(menuname, link, event)
{
	if(NPMIP_Link != null) NPMIP_Link = null;
	NPMIP_Link = link;
	NPMIP_f_PopUp(menuname, event);
}

function NPMIP_f_PopUp(menuname, e){
    if (!NPMIP_AreLoaded) return;
	menuname = menuname.replace("elMenu",NPMIP_MenuIDPrefix);
	var TempMenu = eval("window."+menuname);
	if(!TempMenu)return;
	NPMIP_CurrentMenu = TempMenu;
	if (NPMIP_CurrentMenu.tree.ClickStart) {
		var ClickElement = e.target;
		ClickElement.onclick = NPMIP_f_PopMenu;
    }
	else NPMIP_f_PopMenu(e);
}

function NPMIP_f_PopMenu(e){
    if (!NPMIP_AreLoaded || !NPMIP_AreCreated) return true;
    if (NPMIP_CurrentMenu.tree.ClickStart && e.type != "click") return true;
    NPMIP_f_HideAll();
    NPMIP_CurrentMenu.hasParent = false;
	NPMIP_CurrentMenu.tree.startChild = NPMIP_CurrentMenu;
	var mouse_x_position = e.pageX;
	var mouse_y_position = e.pageY;
	NPMIP_CurrentMenu.xPos = (NPMIP_CurrentMenu.tree.MenuLeft!=null) ? eval(NPMIP_CurrentMenu.tree.MenuLeft) : mouse_x_position;
	NPMIP_CurrentMenu.yPos = (NPMIP_CurrentMenu.tree.MenuTop!=null)  ? eval(NPMIP_CurrentMenu.tree.MenuTop)  : mouse_y_position;

    NPMIP_CurrentMenu.keepInWindow();
    NPMIP_CurrentMenu.moveTo(NPMIP_CurrentMenu.xPos,NPMIP_CurrentMenu.yPos);
    NPMIP_CurrentMenu.isOn = true;
    NPMIP_CurrentMenu.showIt(true);
    return false;
}

function NPMIP_f_MenuOver() {
	if(!this.tree.startChild){this.tree.startChild = this}
	if(this.tree.startChild == this) NPMIP_f_HideAll(this)
    this.isOn = true;
    NPMIP_UserOverMenu = true;
    NPMIP_CurrentMenu = this;
    if (this.hideTimer) clearTimeout(this.hideTimer);
}

function NPMIP_f_MenuOut() {
    this.isOn = false;
    NPMIP_UserOverMenu = false;
    if(NPMIP_StatusDisplayLink) status = "";
    if(!NPMIP_ClickKill) {
		clearTimeout(NPMIP_HideAllTimer);
		NPMIP_HideAllTimer = null;
		NPMIP_HideAllTimer = setTimeout("NPMIP_CurrentMenu.hideTree()",NPMIP_ChildMilliSecondsVisible);
	}
}

function NPMIP_f_ShowChild(){
	if(!this.child) {
		NPMIP_CurrentTree = this.tree;
		NPMIP_CurrentMenu = this.menu;
		NPMIP_CurrentItem = this;
		this.child = NPMIP_f_MakeMenu(this.menu.count + "_"+(this.index+1));
		this.tree.treeParent = this.menu;
		this.tree.startChild = this.menu;
	}
	if (this.tree.PositionUnder && (this.menu == this.tree.treeParent)) {
		this.child.xPos = this.pageX + this.clip.left - NPMIP_BorderWidth;
		this.child.yPos = this.menu.top + this.menu.clip.height - NPMIP_BorderWidth;
	}
	else {
		this.oL = this.pageX;
		this.child.offsetWidth = this.child.clip.width;
		this.oT = this.pageY + this.clip.top - NPMIP_BorderWidth;
		if(this.tree.RightToLeft) {
			this.child.xPos = ((this.oL - this.DistanceToLeftEdge) + this.ChildOverlap) - this.child.offsetWidth;
		}
		else {		
			this.child.xPos = (this.oL + this.DistanceToRightEdge) - this.ChildOverlap;
		}
		this.child.yPos = this.oT + NPMIP_ChildOffset + NPMIP_BorderWidth;
	}
	if(!this.tree.PositionUnder || this.menu!=this.tree.treeParent) this.child.keepInWindow();
	this.child.moveTo(this.child.xPos,this.child.yPos);
	this.menu.hasChildVisible = true;
	this.menu.visibleChild = this.child;
	this.child.showIt(true);
}

function NPMIP_f_ItemOver(){
    if (NPMIP_KeepHilite) {
        if (this.menu.currentItem && this.menu.currentItem != this && this.menu.currentItem.hasRollover) {
            with(this.menu.currentItem){
				bgColor = this.tree.BGColor;
				if(this.tree.NSFontOver) {
    	    	    txtLyrOff.visibility = "inherit";
					txtLyrOn.visibility = "hide";
				}
			}
			if(this.menu.currentItem.hasImageRollover)this.menu.currentItem.imageElement.src = this.menu.currentItem.imageSrc;
        }
    }
	if(this.hasRollover) {
	    this.bgColor = this.tree.BGColorOver;
		if(this.tree.NSFontOver) {
			if(!this.txtLyrOn.isWritten){
				this.txtLyrOn.document.write(this.htmStrOver);
				this.txtLyrOn.document.close();
				this.txtLyrOn.isWritten = true;
			}
			this.txtLyrOff.visibility = "hide";
			this.txtLyrOn.visibility = "inherit";
		}
		if(this.hasImageRollover)this.imageElement.src = this.imageSrcOver;
	}

    if(NPMIP_StatusDisplayLink) status = this.linkText;
    this.menu.currentItem = this;
	if (this.menu.hasChildVisible) {
		if(this.menu.visibleChild == this.child && this.menu.visibleChild.hasChildVisible) this.menu.visibleChild.hideChildren(this);
		else this.menu.hideChildren(this);
    }

    if (this.hasMore && !this.ClickStart) this.showChild();
}

function NPMIP_f_ItemOut() {
    if ( (!NPMIP_KeepHilite || ((this.tree.TopIsPermanent && (this.tree.treeParent==this)) && !this.menu.hasChildVisible)) && this.hasRollover) {
		with(this){
			bgColor = this.tree.BGColor;
			if(this.tree.NSFontOver) {
				txtLyrOff.visibility = "inherit";
				txtLyrOn.visibility = "hide";
			}
			if(this.hasImageRollover)this.imageElement.src = this.imageSrc;
		}
    }
	if(!NPMIP_ClickKill && !NPMIP_UserOverMenu) {
		clearTimeout(NPMIP_HideAllTimer);
		NPMIP_HideAllTimer = null;
        NPMIP_HideAllTimer = setTimeout("NPMIP_CurrentMenu.hideTree()",NPMIP_ChildMilliSecondsVisible);
    }
}

function NPMIP_f_ShowIt(on) {
	if (!(this.tree.TopIsPermanent && (this.tree.treeParent==this))) {
		if(!this.hasParent || (this.hasParent && this.tree.TopIsPermanent && (this.tree.treeParent==this.parentMenu)    )) {
			if (on == this.hidden)
				eval(on ? this.tree.UponDisplay : this.tree.UponHide)
		}
		if (on)
		{
			this.zIndex = ++NPMIP_ZIndex;
			if(NPMIP_Link != null) 
			{
				if(this.dispText)
				{		
					if( (NPMIP_Link.indexOf("ConnectExpert") != -1 && this.dispText.indexOf("Connect") != -1) || (NPMIP_Link.indexOf("ConnectExpert") == -1 && this.dispText.indexOf("Connect") == -1))
					{
						this.linkText = NPMIP_Link;
						this.captureEvents(Event.MOUSEUP);
						this.onclick = NPMIP_f_LinkIt;
					}
				}
			}
		}
		this.visibility = on ? "show" : "hide";
	}
    if (NPMIP_KeepHilite && this.currentItem && this.currentItem.hasRollover) {
        with(this.currentItem){
			bgColor = this.tree.BGColor;
			if(this.tree.NSFontOver) {
				txtLyrOff.visibility = "inherit";
				txtLyrOn.visibility = "hide";
			}
		}
		if(this.currentItem.hasImageRollover)this.currentItem.imageElement.src = this.currentItem.imageSrc;
	}
    this.currentItem = null;
}

function NPMIP_f_KeepInWindow() {
    var ExtraSpace     = 10;
	var WindowLeftEdge = window.pageXOffset;
	var WindowTopEdge  = window.pageYOffset;
	var WindowWidth    = window.innerWidth;
	var WindowHeight   = window.innerHeight;
	var WindowRightEdge  = (WindowLeftEdge + WindowWidth) - ExtraSpace;
	var WindowBottomEdge = (WindowTopEdge + WindowHeight) - ExtraSpace;

	var MenuLeftEdge = this.xPos;
	var MenuRightEdge = MenuLeftEdge + this.clip.width;
	var MenuBottomEdge = this.yPos + this.clip.height;

	if (this.hasParent) {
		var ParentLeftEdge = this.parentItem.pageX;
		this.offsetWidth = this.clip.width;
	}
	if (MenuRightEdge > WindowRightEdge) {
		if (this.hasParent) {
			this.xPos = ((ParentLeftEdge - this.parentItem.DistanceToLeftEdge) + this.parentItem.ChildOverlap) - this.offsetWidth;
		}
		else {
			dif = MenuRightEdge - WindowRightEdge;
			this.xPos -= dif;
		}
		this.xPos = Math.max(5,this.xPos);
	}

	if (MenuBottomEdge > WindowBottomEdge) {
		dif = MenuBottomEdge - WindowBottomEdge;
		this.yPos -= dif;
	}

	if (MenuLeftEdge < WindowLeftEdge) {
		if (this.hasParent) {
			this.xPos = (ParentLeftEdge + this.parentItem.DistanceToRightEdge) - this.parentItem.ChildOverlap;
			MenuRightEdge = this.xPos + this.offsetWidth;
			if(MenuRightEdge > WindowRightEdge) this.xPos -= (MenuRightEdge - WindowRightEdge);
		}
		else {this.xPos = 5}
	}       
}

function NPMIP_f_LinkIt() {
    if (this.linkText.indexOf("javascript:")!=-1) eval(this.linkText)
    else 
    {
		NPMIP_f_HideAll();
		location.href = this.linkText;
    }
}

function NPMIP_f_PopDown(menuname){
    if (!NPMIP_AreLoaded || !NPMIP_AreCreated) return;
	menuname = menuname.replace("elMenu",NPMIP_MenuIDPrefix);
    var MenuToHide = eval("window."+menuname);
	if(!MenuToHide)return;
    MenuToHide.isOn = false;
    if (!NPMIP_ClickKill) MenuToHide.hideTop();
}

function NPMIP_f_HideAll(callingmenu) {
	for(var i=0; i<NPMIP_TotalTrees; i++) {
        var TopMenu = NPMIP_a_TopMenus[i].tree.startChild;
		if(TopMenu == callingmenu)continue
        TopMenu.isOn = false;
        if (TopMenu.hasChildVisible) TopMenu.hideChildren();
        TopMenu.showIt(false);
    }    
}

function NPMIP_f_HideTree() { 
    NPMIP_HideAllTimer = null;
    if (NPMIP_UserOverMenu) return;
    if (this.hasChildVisible) this.hideChildren();
    this.hideParents();
}

function NPMIP_f_HideTop() {
	TopMenuToHide = this;
    (NPMIP_ClickKill) ? TopMenuToHide.hideSelf() : (this.hideTimer = setTimeout("TopMenuToHide.hideSelf()",NPMIP_TopMilliSecondsVisible));
}

function NPMIP_f_HideSelf() {
    this.hideTimer = null;
    if (!this.isOn && !NPMIP_UserOverMenu) this.showIt(false);
}

function NPMIP_f_HideParents() {
    var TempMenu = this;
    while(TempMenu.hasParent) {
        TempMenu.showIt(false);
        TempMenu.parentMenu.isOn = false;        
        TempMenu = TempMenu.parentMenu;
    }
    TempMenu.hideTop();
}

function NPMIP_f_HideChildren(callingitem) {
    var TempMenu = this.visibleChild;
    while(TempMenu.hasChildVisible) {
        TempMenu.visibleChild.showIt(false);
        TempMenu.hasChildVisible = false;
        TempMenu = TempMenu.visibleChild;
    }

    if (!this.isOn || !callingitem.hasMore || this.visibleChild != callingitem.child) {
        this.visibleChild.showIt(false);
        this.hasChildVisible = false;
    }
}

function NPMIP_f_PageClick() {
    if (!NPMIP_UserOverMenu && NPMIP_CurrentMenu!=null && !NPMIP_CurrentMenu.isOn) NPMIP_f_HideAll();
}

popUp = NPMIP_f_PopUp;
popDown = NPMIP_f_PopDown;

NPMIP_f_OtherOnLoad = (window.onload) ? window.onload :  new Function;
window.onload = NPMIP_f_StartIt;

//end